#!/usr/bin/env node
"use strict";
/**
 * Copyright 2020, Google LLC
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const yargs_1 = __importDefault(require("yargs"));
const index_1 = require("./index");
const _ = yargs_1.default
    .scriptName("create-local-home-app")
    .usage("$0 [project-directory]", "Initialize a new Local Home SDK application", (y) => {
    return y
        .positional("project-directory", {
        describe: "New project destination directory",
    })
        .option("template", {
        default: path.join(__dirname, "app"),
        hidden: true,
    })
        .option("bundler", {
        choices: Object.values(index_1.Bundler),
        demandOption: "You must choose a bundler configuration",
        describe: Object.entries({
            [index_1.Bundler.WEBPACK]: "Bundle dependencies with Webpack",
            [index_1.Bundler.ROLLUP]: "Bundle dependencies with Rollup",
            [index_1.Bundler.PARCEL]: "Bundle dependencies with Parcel",
            [index_1.Bundler.NONE]: "Compile TypeScript without bundling dependencies",
        }).reduce((acc, [bundler, desc]) => acc + `${bundler}:\t${desc}\n`, "Specify a bundler configuration\n"),
    });
}, (argv) => {
    if (argv.projectDirectory === undefined) {
        yargs_1.default.showHelp();
        console.error("Missing required positional argument: project-directory");
        console.error("You must specificy a destination project directory");
        process.exit(1);
    }
    index_1.createLocal(argv.bundler, argv.template, argv.projectDirectory);
})
    .help()
    .argv;
